extends Node3D

var light_on: bool = true

func _ready():
	var tween = get_tree().create_tween()
	tween.set_parallel(true)
	tween.tween_property($Player/DirectionalLight3D, "rotation_degrees", Vector3(270, 0, 0), 2).set_trans(tween.EASE_OUT)
	tween.tween_property($Player/DirectionalLight3D, "light_energy", 1, 2).set_trans(tween.EASE_OUT)

func light_orb_visible():
	$LightOrb.light_orb_visible()

func light_on_off():
	if light_on:
		light_on = false
		var tween = get_tree().create_tween()
		tween.set_parallel(true)
		tween.tween_property($Player/DirectionalLight3D, "rotation_degrees", Vector3(90, 0, 0), 2).set_trans(tween.EASE_OUT)
		tween.tween_property($Player/DirectionalLight3D, "light_energy", 0, 2).set_trans(tween.EASE_OUT)
	else:
		light_on = true
		var tween = get_tree().create_tween()
		tween.set_parallel(true)
		tween.tween_property($Player/DirectionalLight3D, "rotation_degrees", Vector3(270, 0, 0), 2).set_trans(tween.EASE_OUT)
		tween.tween_property($Player/DirectionalLight3D, "light_energy", 1, 2).set_trans(tween.EASE_OUT)

func shake_forward():
	var tween = get_tree().create_tween()
	tween.tween_property($Camera, "rotation_degrees", Vector3(-72.5, 0, 0), 0.1).set_trans(tween.EASE_OUT)
	tween.tween_property($Camera, "rotation_degrees", Vector3(-75, 0, 0), 0.1).set_trans(tween.EASE_IN)

func shake_back():
	var tween = get_tree().create_tween()
	tween.tween_property($Camera, "rotation_degrees", Vector3(-77.5, 0, 0), 0.1).set_trans(tween.EASE_OUT)
	tween.tween_property($Camera, "rotation_degrees", Vector3(-75, 0, 0), 0.1).set_trans(tween.EASE_IN)

func shake_left():
	var tween = get_tree().create_tween()
	tween.tween_property($Camera, "rotation_degrees", Vector3(-75, 0, -5), 0.1).set_trans(tween.EASE_OUT)
	tween.tween_property($Camera, "rotation_degrees", Vector3(-75, 0, 0), 0.1).set_trans(tween.EASE_IN)

func shake_right():
	var tween = get_tree().create_tween()
	tween.tween_property($Camera, "rotation_degrees", Vector3(-75, 0, 5), 0.1).set_trans(tween.EASE_OUT)
	tween.tween_property($Camera, "rotation_degrees", Vector3(-75, 0, 0), 0.1).set_trans(tween.EASE_IN)

func _on_light_timer_timeout():
	var tween = get_tree().create_tween()
	tween.set_parallel(true)
#	tween.tween_property($Camera, "h_offset", 0, 2).set_trans(tween.EASE_OUT)
#	tween.tween_property($Camera, "v_offset", 3, 2).set_trans(tween.EASE_OUT)
	tween.tween_property($Camera, "size", 10, 2).set_trans(tween.EASE_OUT)
	tween.tween_property($Camera, "rotation_degrees", Vector3(-75, 0, 0), 2).from(Vector3(-70, 15, 15)).set_trans(tween.EASE_OUT)

func zoom_in():
	var tween = get_tree().create_tween()
	tween.set_parallel(true)
	tween.tween_property($Camera, "size", 5, 2).set_trans(tween.EASE_OUT)
#	tween.tween_property($Camera, "h_offset", 0, 2).set_trans(tween.EASE_OUT)
#	tween.tween_property($Camera, "v_offset", 3, 2).set_trans(tween.EASE_OUT)
	tween.tween_property($Camera, "rotation_degrees", Vector3(-70, 15, 15), 2).set_trans(tween.EASE_OUT)
	tween.tween_property($Water, "position", Vector3(0, 4, 0), 2)
